// ********************************************************************************************************************
//  File Name				: VipUpdateData.cpp
//  Description				: ZIPC VIPf[^ǗNXwb_t@CiBCBpj
// ********************************************************************************************************************


// ********************************************************************************************************************
//							Include Section
// ********************************************************************************************************************
#include <vcl.h>
#include "ZVipPnlImp.h"
#include "VipCommunicate.h"
#include "VipUpdateData.h"


// ********************************************************************************************************************
//							Grobal Func
// ********************************************************************************************************************
extern HINSTANCE GetDllInst( void );


// ********************************************************************************************************************
//							CVipUpdateData NX o֐
// ********************************************************************************************************************

// ********************************************************************************************************************
// Function Name			: CVipUpdateData
// Description				: CVipUpdateData NX̍\z
// ********************************************************************************************************************
CVipUpdateData::CVipUpdateData()
{
	m_nMode		= ZIPCVIP_DATA_UNDEF;
	m_nIndex	= -1;
	m_pData		= NULL;
	m_bReset	= FALSE;
	m_nTimerID	= -1;

	return;
}


// ********************************************************************************************************************
// Function Name			: ~CVipUpdateData
// Description				: CVipUpdateData NX̏
// ********************************************************************************************************************
CVipUpdateData::~CVipUpdateData()
{
	InitialData();
}


// ********************************************************************************************************************
// Function Name			: InitialData
// Description				: XV폜
// ********************************************************************************************************************
void CVipUpdateData::InitialData( void )
{
	m_nMode		= ZIPCVIP_DATA_UNDEF;
	m_nIndex	= -1;
	m_bReset	= FALSE;
	m_nTimerID	= -1;

	//	f[^̈悪mۂĂ邩H
	if( m_pData != NULL ) {
		//	f[^̈̉s
		delete	[]	m_pData;
	}
	else{
		// none
	}
	m_pData		= NULL;

	return;
}


// ********************************************************************************************************************
// Function Name			: VIP_PnlMessageProc
// Description				: ZIPC VIPƂ̒ʐMe͂s
// Return					: s
// Parameter				: wParamibZ[WWPARAMlj
// 							: lParamibZ[WLPARAMlj
// ********************************************************************************************************************
BOOL CVipUpdateData::VipMessage( WPARAM wParam, LPARAM lParam )
{
	//	Mf[^i[GȀ
	InitialData();

	BOOL	bRet = FALSE;
	switch( wParam ) {
		case VIP_END_EVENT:					// ZIPC VIP Iʒm
		    exit(EXIT_SUCCESS);
			bRet = TRUE;
	      	break;

		case VIP_RESET_EVENT:				// ZIPCZbgʒm
			m_bReset	= TRUE;
            bRet		= TRUE;
			break;

		case VIP_CHGVALUE_EVENT:			// lXVʒm
			bRet = AnalysisAttribute( HIWORD(lParam), LOWORD(lParam) );
			break;

		case VIP_TIMEOUT_EVENT:				// V~[V^C} ^CAEgʒm
			//	^C}͎gpȂ̂ŁA
			m_nTimerID	= lParam;
			bRet		= TRUE;
			break;

		case VIP_ACTIVEMODE_END:			// Oϐ}̏Iʒm
			exit(EXIT_SUCCESS);
			bRet = TRUE;
			break;

		default:
			// none
			break;
	}

	return	bRet;
}


// ********************************************************************************************************************
// Function Name			: VIP_OutputData
// Description				: lXVʒm̃f[^͂
// Return					: ͌
// Parameter				: nModeif[^j
// 							: nNoif[^ڔԍj
// ********************************************************************************************************************
BOOL CVipUpdateData::AnalysisAttribute( int nMode, int nNo )
{
	BOOL	bRet = FALSE;
	switch( nMode ) {
		case VIP_PIO_DATA:
			bRet = AnalysisPio( nNo );
			break;
		case VIP_ANG_DATA:
			bRet = AnalysisAng( nNo );
			break;
		case VIP_STR_DATA:
			bRet = AnalysisStr( nNo );
			break;
		default:
			// none
			break;
	}

	return	bRet;
}


// ********************************************************************************************************************
// Function Name			: SetValuePio
// Description				: |[gf[^ݒ肷
// Return					: ݒ茋
// Parameter				: nNoif[^ڔԍj
// ********************************************************************************************************************
BOOL CVipUpdateData::AnalysisPio( int nNo )
{
	//	DLL[hĂ邩H
	BOOL		bRet		= FALSE;
	HINSTANCE	ahDLLInst	= GetDllInst();
	if( ahDLLInst != NULL ) {
		ZVIP_GETPORTSIZE lpGetPortSize = (ZVIP_GETPORTSIZE)GetProcAddress( ahDLLInst, "ZVIP_GetPortSize" );
		if( lpGetPortSize != NULL ) {
	    	long nSize = 0;
			//	f[^TCY̎擾s
   			long	nParam = 0;
			lpGetPortSize( nNo, &nSize, &nParam);
			ZVIP_GETPORTIDDATA lpGetPortData = (ZVIP_GETPORTIDDATA)GetProcAddress( ahDLLInst, "ZVIP_GetPortIDData" );
			if( lpGetPortData != NULL ) {
 				//	f[^̎擾s
        	   	void* data = new BYTE[nSize*nParam];
				if( lpGetPortData( nNo, data, nParam ) != FALSE ){
					//	f[^̐ݒs
					SetValue( ZIPCVIP_DATA_PIO, nNo, data );
					bRet = TRUE;
				}
				else{
					delete [] data;
				}
			}
			else {
				// none
			}
		}
		else{
			// none
		}
	}
	else {
		// none
	}

	return bRet;
}


// ********************************************************************************************************************
// Function Name			: VIP_OutputDataAng
// Description				: AiOf[^ݒ肷
// Return					: ݒ茋
// Parameter				: nNoif[^ڔԍj
// ********************************************************************************************************************
BOOL CVipUpdateData::AnalysisAng( int nNo )
{
	//	DLL[hĂ邩H
	BOOL		bRet		= FALSE;
	HINSTANCE	ahDLLInst	= GetDllInst();
	if( ahDLLInst != NULL ) {
		ZVIP_GETANGIDDATA lpGetAngData = (ZVIP_GETANGIDDATA)GetProcAddress( ahDLLInst, "ZVIP_GetAngIDData" );
		if( lpGetAngData != NULL ) {
			//	f[^̎擾s
       	   	void* data = new double[1];
			if( lpGetAngData( nNo, (double*)data ) != FALSE ){
				//	f[^̐ݒs
				SetValue( ZIPCVIP_DATA_ANG, nNo, data );
				bRet = TRUE;
			}
			else{
				delete [] data;
			}
		}
		else {
			// none
		}
	}
	else {
		// none
	}

	return bRet;
}


// ********************************************************************************************************************
// Function Name			: VIP_OutputDataStr
// Description				: f[^擾
// Return					: 擾
// Parameter				: nNoif[^ڔԍj
// ********************************************************************************************************************
BOOL CVipUpdateData::AnalysisStr( int nNo )
{
	//	DLL[hĂ邩H
	BOOL		bRet		= FALSE;
	HINSTANCE	ahDLLInst	= GetDllInst();
	if( ahDLLInst != NULL ) {
		ZVIP_GETSTRINGSIZE lpGetStrSize = (ZVIP_GETSTRINGSIZE)GetProcAddress( ahDLLInst, "ZVIP_GetStringSize" );
		if( lpGetStrSize != NULL ) {
			//	f[^TCY̎擾s
			long	nParam = 0;
			lpGetStrSize( nNo, &nParam );
			ZVIP_GETSTRINGIDDATA lpGetStringData = (ZVIP_GETSTRINGIDDATA)GetProcAddress( ahDLLInst, "ZVIP_GetStringIDData" );
			if( lpGetStringData != NULL ) {
				void* data = new char[nParam];
				//	f[^̎擾s
				if( lpGetStringData( nNo, (LPSTR)data, nParam ) != FALSE ){
					//	f[^̐ݒs
					SetValue( ZIPCVIP_DATA_STR, nNo, data );
					bRet = TRUE;
				}
				else{
					delete [] data;
				}
			}
			else {
				// none
			}
		}
		else {
			// none
		}
	}
	else {
		// none
	}

	return bRet;
}


// ********************************************************************************************************************
// Function Name			: VIP_IsUpdateData
// Description				: XV񂪐ݒ肳Ă邩mF
// Return					: mF
// ********************************************************************************************************************
BOOL CVipUpdateData::IsUpdateData(void)
{
	BOOL	bRet = FALSE;

	//	XVf[^ǗNXɃf[^̈悪ݒ肳Ă邩H
	if( GetUpdateData() != NULL ) {
		bRet = TRUE;
	}
	else {
		// none
	}

	return	bRet;
}


// ********************************************************************************************************************
// Function Name			: SetValue
// Description				: XVlݒ肷
// Return					: ݒ茋
// Parameter				: modeif[^j
// 							: indexif[^ڔԍj
// 							: pDataif[^i[AhXj
// ********************************************************************************************************************
void CVipUpdateData::SetValue( enum ZIPCVIP_DATAMODE mode, int index, void* pData )
{
	m_nMode		= mode;
	m_nIndex	= index;
	m_pData		= pData;

	return;
}


// ********************************************************************************************************************
// Function Name			: GetUpDataMode
// Description				: XV̑擾
// Return					: f[^
// ********************************************************************************************************************
enum ZIPCVIP_DATAMODE CVipUpdateData::GetUpdateMode( void )
{
	return m_nMode;
}


// ********************************************************************************************************************
// Function Name			: GetUpdateIndex
// Description				: XV̍ڔԍ擾
// Return					: f[^ڔԍ
// ********************************************************************************************************************
int CVipUpdateData::GetUpdateIndex( void )
{
	return m_nIndex;
}


// ********************************************************************************************************************
// Function Name			: GetUpdateIndex
// Description				: XV̎f[^擾
// Return					: f[^i[AhX
// ********************************************************************************************************************
void* CVipUpdateData::GetUpdateData( void )
{
	return m_pData;
}


// ********************************************************************************************************************
// Function Name			: IsReset
// Description				: XV񂪃ZbgǂmF
// Return					: mF
// ********************************************************************************************************************
BOOL CVipUpdateData::IsReset( void )
{
	return m_bReset;
}


// ********************************************************************************************************************
// Function Name			: GetTimerId
// Description				: TimerID擾
// Return					: TimerID
// ********************************************************************************************************************
int CVipUpdateData::GetTimerId( void )
{
	return m_nTimerID;
}


